*-- Procedure        : posgets
*-- Author           : Joe Hilger Mods by Harold Chattaway
*-- Project          : 
*-- Created          : 09/94
*-- Copyright        : Public Domain
*-- Description      : Changes vpos and hpos in scx to be relative to 
*--                    box object containing gets.
*-- Calling Sample   : _scxdrv4=posgets
*-- Parameters       : None
**************************************************************************

#define WINNAME		1
#define WINX1		2
#define WINY1		3
#define WINX2		4
#define WINY2		5

PRIVATE ALL LIKE l*

*--- Variable Declaration
DIMENSION laWinInfo[1,5]
m.lnVPos = 0
m.lnHPos = 0
m.lnBVPos = 0
m.lnBHPos = 0
m.lnWinCnt = 0
m.lnCntr = 0
m.lcContain = " "
m.llWind = .F.

*--- Get the Container Window Name
m.lcsuffix = alltrim(substr(mline(m.setupcode,atcline("*:suffix",m.setupcode)), ;
         at(" ",mline(m.setupcode,atcline("*:suffix",m.setupcode)))+1))
         
m.lccontain = alltrim(substr(mline(m.setupcode,atcline("*:container",m.setupcode)), ;
         at(" ",mline(m.setupcode,atcline("*:container",m.setupcode)))+1))       

*--- Scan to Find the *:CONTAINER directives
*--- This will eventually be an array that will allow for multiple
*--- get windows (ie. regions).


SCAN FOR ObjType = 7 and platform = m.platform_
	m.lnlineno = ATCLINE("*:ADJUSTGETS",Comment)
	IF m.lnLineNo > 0

*--- Building an Array of Window Locations
		m.lcLine = ALLTRIM(MLINE(Comment, m.lnLineNo))
		m.lcWin = ALLTRIM(SUBSTR(m.lcLine,at(" ",m.lcline)))
		m.lnVPos = VPos
		m.lnHPos = HPos
		m.lnBVPos = m.lnVPos + Height
		m.lnBHPos = m.lnHPos + Width
		m.lnWinCnt = m.lnWinCnt + 1
		IF m.lnWinCnt = 1
			laWinInfo[1, WINNAME] = m.lcWin
			laWinInfo[1, WINX1] = m.lnVPos
			laWinInfo[1, WINY1] = m.lnHPos
			laWinInfo[1, WINX2] = m.lnBVPos
			laWinInfo[1, WINY2] = m.lnBHPos

		ELSE
			DIMENSION laWinInfo[m.lnWinCnt, 5]
			laWinInfo[m.lnWinCnt, WINNAME] = m.lcWin
			laWinInfo[m.lnWinCnt, WINX1] = m.lnVPos
			laWinInfo[m.lnWinCnt, WINY1] = m.lnHPos
			laWinInfo[m.lnWinCnt, WINX2] = m.lnBVPos
			laWinInfo[m.lnWinCnt, WINY2] = m.lnBHPos
		ENDIF
	ENDIF

ENDSCAN

*--- check to make sure there is at least one box object...
if lnwincnt = 0
   go bottom
   return .t.
endif lnwincnt   
   


*--- Scan through the temporary Cursor to change HPos and VPos
SCAN FOR ObjType > 4 and platform = m.platform_

*--- Check to See if the Get is in a Box Region
	m.llWind = .F.
	FOR m.lnCntr = 1 TO ALEN(laWinInfo,1)
		IF BETWEEN(VPos, laWinInfo[m.lnCntr, WINX1], ;
						 laWinInfo[m.lnCntr, WINX2]) AND ;
				BETWEEN(HPos, laWinInfo[m.lnCntr, WINY1], ;
							  laWinInfo[m.lnCntr, WINY2])
			REPLACE VPos WITH (VPos - laWinInfo[m.lnCntr, WINX1]), ;
					HPos WITH (HPos - laWinInfo[m.lnCntr, WINY1])
			= INSCMD("ACTIVATE WINDOW " + laWinInfo[m.lnCntr, WINNAME] + ;
			  lcsuffix + " SAME", -1, .F.)
			m.llWind = .T.
			EXIT
		ENDIF
	NEXT m.lnCntr
	
*--- If an object was painted on the container window, 
*--- Put it in the Container Window!
	IF !(m.llWind)
		IF !EMPTY(m.lcContain)
			= INSCMD("ACTIVATE WINDOW " + m.lcContain + " SAME", -1, .F.)
		ENDIF
	ENDIF

ENDSCAN
RETURN .T.